Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_parameters_window.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_parameters_window.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_parameters_window.cpp	(revision 30)
@@ -10,9 +10,15 @@
 {
   wparam = new QWidget();
-  QBoxLayout *parameters = new QBoxLayout(QBoxLayout::LeftToRight,0);
-  wparam->resize(200,450);
+  parameters = new QBoxLayout(QBoxLayout::TopToBottom,0);
   wparam->setWindowTitle("parameters");
-  wparam->setFixedSize(200,620);
-  wparam->move(816,0);
+  wparam->setFixedSize(350,300);
+  wparam->move(628,370);
+
+  
+  QPushButton *apply = new QPushButton("apply",wparam);
+  connect(apply,SIGNAL(clicked()),this,SLOT(_apply()));
+  
+  parameters->addWidget(apply);
+
   wparam->setLayout(parameters);
   wparam->show();
@@ -20,3 +26,5 @@
 
 
-
+void Window::_apply(){
+  cout << "apply\n";
+}
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_setParse.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_setParse.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_setParse.cpp	(revision 30)
@@ -11,5 +11,4 @@
   if(p)
     parse=p;
-  else
-    cout<<"eee";
+
 }
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_tools_actions.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_tools_actions.cpp	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Graphics/src/Graphics_tools_actions.cpp	(revision 30)
@@ -0,0 +1,65 @@
+#include "window.h"
+
+using namespace std;
+using namespace morpheo::tools::viewer::parser;
+using namespace morpheo::tools::viewer::bdd;
+using namespace morpheo::tools::viewer::graphics;
+
+void Window::_zoomIn(){
+  cout << "zoom in" << endl;
+}
+
+void Window::_zoomOut(){
+  cout << "zoom out" << endl;
+}
+
+void Window::_defautZoom(){
+  cout << "defaut zoom" << endl;
+}
+
+void Window::_level(){
+  cout << "level" <<endl;
+}
+
+void Window::_informations(){
+  if(!info_open){//if the informations window is not open, open it,else close it
+    this->winformations();
+    info_open = true;
+  }
+  else{ 
+    winfo->close();
+    info_open = false;
+  }
+}
+
+void Window::_parameters(){//if the parameteres  window is not open, open it,else close it
+  if(!param_open){
+    this->wparameters();
+    param_open = true;
+  }
+  else{ 
+    wparam->close();
+    param_open = false;
+  }
+}
+
+void Window::_component_name(){
+
+  if(componentName)
+    componentName = false;
+
+  else componentName = true;
+
+  repaint();
+}
+
+void Window::_signal_name(){
+
+  if(signalName)
+    signalName = false;
+
+  else 
+    signalName = true;
+
+  repaint();
+}
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/include/parser.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/include/parser.h	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/include/parser.h	(revision 30)
@@ -17,5 +17,5 @@
 #include "Tools/Viewer/Bdd/include/PortMap.h"
 
-
+#define LEVEL_MAX 8
 
 using namespace std;
@@ -32,14 +32,13 @@
   string s;
   string absolutePath;
+  string toplevel;
 
-protected:
   morpheo::tools::viewer::bdd::BaseV *base;
   morpheo::tools::viewer::bdd::BaseP *pos;
-  morpheo::tools::viewer::bdd::Entity *ent;
-  morpheo::tools::viewer::bdd::Architecture *arch;
-  morpheo::tools::viewer::bdd::Component *ctemp;
-  //  morpheo::tools::viewer::bdd::Param *param;
-
-
+  morpheo::tools::viewer::bdd::Entity *ent[LEVEL_MAX];
+  morpheo::tools::viewer::bdd::Architecture *arch[LEVEL_MAX];
+  morpheo::tools::viewer::bdd::Component *ctemp[LEVEL_MAX];
+  
+protected:
 
 public:
@@ -47,11 +46,13 @@
   Parse(void);
   ~Parse(void);
-  void parser_pos(QDomNode n);
-  //void ParseParam(void);
-  int open_file(string name);
+  void parser_pos(QDomNode n,int level);
+
+  int open_file(string name,int level);
   //void saveFile(string name);
   morpheo::tools::viewer::bdd::BaseV *getBaseV();
-
- 
+  string getTopLevelName();
+  string getAbsolutePath();
+  /*Close and erase baseV*/
+  void closeBaseV();
  //void refresh();
  
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_accessors.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_accessors.cpp	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_accessors.cpp	(revision 30)
@@ -0,0 +1,23 @@
+/*
+ *
+ * [desc.]
+ */
+#include "Tools/Viewer/Parser/include/parser.h"
+
+namespace morpheo{
+namespace tools{
+namespace viewer{
+namespace parser{
+
+  string Parse::getTopLevelName(){
+    return toplevel;
+  }
+  string Parse::getAbsolutePath(){
+    return absolutePath;
+  }
+
+
+};//end parser
+};//end viewer
+};//end tools
+};//end morpheo
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_closeBaseV.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_closeBaseV.cpp	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_closeBaseV.cpp	(revision 30)
@@ -0,0 +1,32 @@
+/*
+ *
+ * [desc.]
+ */
+#include "Tools/Viewer/Parser/include/parser.h"
+
+namespace morpheo{
+namespace tools{
+namespace viewer{
+namespace parser{
+
+   void Parse::closeBaseV(){
+     int i;
+     for(i==0;i<LEVEL_MAX;i++)
+      {
+      delete ctemp[i];
+      delete arch[i];
+      delete ent[i];
+     }
+     delete pos;
+     delete base;
+     toplevel.clear();
+     absolutePath.clear();
+     base=NULL;
+     
+   }
+
+
+};//end parser
+};//end viewer
+};//end tools
+};//end morpheo
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_open_file.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_open_file.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_open_file.cpp	(revision 30)
@@ -10,12 +10,20 @@
 namespace parser{
 
-   int Parse::open_file(string name){
+   int Parse::open_file(string name,int level){
+
     QFile file(QString::fromStdString(name));
+    QString testname,testname2;
     QString tmppath=QString::fromStdString(name);
-
     QString path=tmppath.left(tmppath.lastIndexOf('/',-1,Qt::CaseSensitive)+1);
-
     absolutePath=path.toStdString();
-
+    testname=tmppath.right(tmppath.lastIndexOf('.',-1,Qt::CaseSensitive)-1);
+    testname2=testname.left(testname.lastIndexOf('.',-1,Qt::CaseSensitive));
+    
+    if(tmppath.contains('-') && level==0) //file not top level (first open file)
+      {
+	testname2=testname2.left(testname2.lastIndexOf('-',-1,Qt::CaseSensitive));
+      }
+    
+    
      if( !file.open( QIODevice::ReadOnly ) )
        {
@@ -44,14 +52,17 @@
          #endif
 	 //BaseP
-	 if(!base)
-	   base=new morpheo::tools::viewer::bdd::BaseV();
+	 if(!base){
+	   base=new morpheo::tools::viewer::bdd::BaseV(); 
+	   toplevel=testname2.toStdString();
+	 }
 	 pos=new morpheo::tools::viewer::bdd::BaseP();
 	 //base->addBaseP(pos);
-	 parser_pos(root.firstChild());    
+	 parser_pos(root.firstChild(),level);    
 	 
        }
+
+     //     delete pos;
+     //delete ctemp;
      return 0;
-
-
    }
 
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_parser_pos.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_parser_pos.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Parser/src/Parse_parser_pos.cpp	(revision 30)
@@ -10,5 +10,6 @@
 namespace parser{     
 
-  void Parse::parser_pos(QDomNode n){
+  void Parse::parser_pos(QDomNode n,int level){
+    string fichier;
        while( !n.isNull() )
       {
@@ -25,17 +26,22 @@
 		//BaseP
 		pos->setComment(e.text().toStdString());
+		pos->setLevel(level);
+		
 	      }
 	    if (e.tagName() == "entity" )
 	      {
-                #ifdef DBUG_PARSE
+		#ifdef DBUG_PARSE
 		cout << "entity" <<endl;
 		cout << e.attribute("name","").toStdString() <<endl;
 		#endif
-		ent=new morpheo::tools::viewer::bdd::Entity\
+
+		ent[level]=new morpheo::tools::viewer::bdd::Entity\
 		  (e.attribute("name","").toStdString(),\
+		   e.attribute("type","").toStdString(),\
 		   e.attribute("schema","").toInt(0,10));
-		s=e.attribute("type","").toStdString();
-		pos->setEntity(ent);
-		parser_pos(n.firstChild());
+		s=e.attribute("name","").toStdString();
+		pos->setEntity(ent[level]);
+
+		parser_pos(n.firstChild(),level);
 		
 		if((n.nextSiblingElement()).tagName() !="architecture")
@@ -59,5 +65,5 @@
 		       e.attribute("localisation","").toStdString());
 		p->setComment(e.text().toStdString());
-		ent->addport(p);
+		ent[level]->addport(p);
 	      } 
 	    if (e.tagName() == "architecture" )
@@ -66,10 +72,10 @@
 		cout << "architecture" <<endl;
 		#endif
-		arch=new morpheo::tools::viewer::bdd::Architecture();
-		pos->setArchitecture(arch);
+		arch[level]=new morpheo::tools::viewer::bdd::Architecture();
+		pos->setArchitecture(arch[level]);
 		
 		base->addBaseP(pos,s);
 
-		parser_pos(n.firstChild());    
+		parser_pos(n.firstChild(),level);    
 	      } 
 	    if (e.tagName() == "component" )
@@ -86,20 +92,25 @@
 			    e.attribute("size_x","").toInt(0,10),\
 			    e.attribute("size_y","").toInt(0,10));
-		arch->addComponent(comp, e.attribute("type","").toStdString());
-		ctemp=comp;
+		ctemp[level]=comp;
+		arch[level]->addComponent(ctemp[level], e.attribute("name","").toStdString());
 		
-		string fichier=absolutePath;
-		fichier.append(e.attribute("type","").toStdString());
+		fichier=absolutePath;
+		fichier.append(ent[level]->getName());
+		fichier.append("-");
+		fichier.append((e.attribute("type","").toLower()).toStdString());
 		fichier.append(".pos");
-		#ifdef DBUG_PARSE
-		cout << fichier <<endl;
-		#endif
-		open_file(fichier);
-		parser_pos(n.firstChild());    
+          #ifdef DBUG_PARSE
+		cout << fichier <<endl; 
+          #endif
+		if(open_file(fichier,level+1)==-1)
+		  exit(1);
+		
+		parser_pos(n.firstChild(),level);    
+		
 		//ajout ptr Port du sous composant
-		BaseP pt=base->get_BasePos(e.attribute("type","").toStdString());
+		BaseP pt=base->get_BasePos((e.attribute("type","").toLower()).toStdString());
 		QList<Port> *sspor= (pt.getEntity())->getPort();
 		for(QList<Port>::iterator it=sspor->begin();it!=sspor->end();++it)
-		  ctemp->addport(new Port(*it));
+		  ctemp[level]->addport(new Port(*it));
 		
 	      } 
@@ -115,5 +126,5 @@
 			  e.attribute("port","").toStdString());
 		
-		ctemp->addPortMap(p);
+		ctemp[level]->addPortMap(p);
 		
 	      } 
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Viewer.pro
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Viewer.pro	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/Viewer.pro	(revision 30)
@@ -40,9 +40,7 @@
 			Bdd/include/Entity.h  						\
 			Bdd/include/ListePorts.h  					\
-#			Bdd/include/ListV.h  						\
 			Bdd/include/Port.h  						\
 			Bdd/include/PortMap.h  						\
 			Bdd/include/Signal.h  						\
-#			Graphics/include/point.h  					\
 			Graphics/include/window.h  					\
 			Parser/include/parser.h
@@ -94,5 +92,7 @@
 			Bdd/src/ListePorts_accessors.cpp				\
 			Bdd/src/ListePorts_searchPort.cpp				\
-			Parser/src/Parse_alloc.cpp					\
+			Parser/src/Parse_alloc.cpp					\		
+                        Parser/src/Parse_closeBaseV.cpp					\
+			Parser/src/Parse_accessors.cpp					\
 			Parser/src/Parse_parser_pos.cpp					\
 			Parser/src/Parse_getBaseV.cpp					\
@@ -100,5 +100,7 @@
 			Parser/src/Parse_open_file.cpp					\
 			Graphics/src/Graphics_main.cpp					\
-			Graphics/src/Graphics_window_actions.cpp			\
+			Graphics/src/Graphics_file_actions.cpp				\
+			Graphics/src/Graphics_tools_actions.cpp				\
+			Graphics/src/Graphics_about_actions.cpp				\
 			Graphics/src/Graphics_main_window.cpp				\
 			Graphics/src/Graphics_informations_window.cpp			\
@@ -106,3 +108,5 @@
 			Graphics/src/Graphics_parameters_window.cpp			\
 			Graphics/src/Graphics_setParse.cpp				\
-			Graphics/src/Graphics_drawAll.cpp				
+			Graphics/src/Graphics_drawAll.cpp				\
+			Graphics/src/Graphics_mouseEvent.cpp	
+			
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/branch_history_table-meta_predictor.pos
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/branch_history_table-meta_predictor.pos	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/branch_history_table-meta_predictor.pos	(revision 30)
@@ -0,0 +1,73 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<description>
+
+   <comment>     Test composant sans architecture   </comment>
+
+   <entity name="meta_predictor"
+           type="Meta_Predictor"
+           schema="1" >
+
+      <port name="clock"           
+            localisation="west" 
+            direction="in">
+        Port d'horloge                                                    
+      </port>
+      <port name="predict"         
+            localisation="west" 
+            direction="in">
+        Interface de prediction : demande de la direction pour une adresse
+      </port>
+      <port name="branch_complete" 
+            localisation="east"
+            direction="in">
+        Interface de mise à jour des branchement                           
+      </port>
+
+   </entity>
+
+
+   <architecture>
+
+      <component name="meta_register_1"
+                 type="Meta_Register"
+                 size_x="10"
+                 pos_x="50"
+                 size_y="10"
+                 pos_y="50" >
+
+         <port_map name="clock"        
+                   component="meta_predictor"
+                   port="clock" />
+         <port_map name="predict" 
+                   component="meta_predictor"
+                   port="predict"/>
+         <port_map name="branch_complete"
+                   component="meta_predictor"
+                   port="branch_complete" />
+
+      </component>
+
+     <component name="meta_register_2"
+                 type="Meta_Register"
+                 size_x="10"
+                 pos_x="50"
+                 size_y="10"
+                 pos_y="20" >
+
+         <port_map name="clock"        
+                   component="meta_predictor"
+                   port="clock" />
+         <port_map name="predict" 
+                   component="meta_predictor"
+                   port="predict"/>
+         <port_map name="branch_complete"
+                   component="meta_predictor"
+                   port="branch_complete" />
+
+      </component>
+
+   </architecture>
+   
+
+</description>
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/meta_predictor-meta_register.pos
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/meta_predictor-meta_register.pos	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/meta_predictor-meta_register.pos	(revision 30)
@@ -0,0 +1,31 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<description>
+
+   <comment>     Test composant sans architecture   </comment>
+
+   <entity name="meta_register"
+           type="Meta_Register"
+           schema="1" >
+
+      <port name="clock"           
+            localisation="west" 
+            direction="in">
+        Port d'horloge                                                    
+      </port>
+      <port name="predict"         
+            localisation="west" 
+            direction="in">
+        Interface de prediction : demande de la direction pour une adresse
+      </port>
+      <port name="branch_complete" 
+            localisation="east"
+            direction="in">
+        Interface de mise à jour des branchement                           
+      </port>
+
+   </entity>
+
+   
+
+</description>
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor-branch_history_table.pos
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor-branch_history_table.pos	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor-branch_history_table.pos	(revision 30)
@@ -0,0 +1,73 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<description>
+
+   <comment>
+     Ce composant décrit la table d'historique de branchement à deux niveaux
+   </comment>
+
+   <entity name="branch_history_table"
+           type="Branch_History_Table"
+           schema="2" >
+
+      <port name="clock"           
+            localisation="west" 
+            direction="in">
+        Port d'horloge                                                    
+      </port>
+      <port name="predict"         
+            localisation="west" 
+            direction="in">
+        Interface de prediction : demande de la direction pour une adresse
+      </port>
+      <port name="branch_complete" 
+            localisation="east"
+            direction="in">
+        Interface de mise à jour des branchement                           
+      </port>
+
+   </entity>
+
+   <architecture>
+
+      <component name="meta_predictor"
+                 type="Meta_Predictor"
+                 size_x="10"
+                 pos_x="50"
+                 size_y="10"
+                 pos_y="20" >
+
+         <port_map name="clock"        
+                   component="branch_history_table"
+                   port="clock" />
+         <port_map name="predict" 
+                   component="branch_history_table"
+                   port="predict"/>
+         <port_map name="branch_complete"
+                   component="branch_history_table"
+                   port="branch_complete" />
+
+      </component>
+<!--
+     <component name="meta_predictor"
+                 type="Meta_Predictor"
+                 size_x="10"
+                 pos_x="50"
+                 size_y="10"
+                 pos_y="20" >
+
+         <port_map name="clock"        
+                   component="branch_history_table"
+                   port="clock" />
+         <port_map name="predict" 
+                   component="branch_history_table"
+                   port="predict"/>
+         <port_map name="branch_complete"
+                   component="branch_history_table"
+                   port="branch_complete" />
+
+      </component>
+-->
+   </architecture>
+
+</description>
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor-pattern_history_table.pos
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor-pattern_history_table.pos	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor-pattern_history_table.pos	(revision 30)
@@ -0,0 +1,33 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<description>
+
+   <comment>
+     Test composant sans architecture
+   </comment>
+
+   <entity name="pattern_history_table"
+           type="Pattern_History_Table"
+           schema="3" >
+
+      <port name="clock"           
+            localisation="west" 
+            direction="in">
+        Port d'horloge                                                    
+      </port>
+      <port name="predict"         
+            localisation="west" 
+            direction="in">
+        Interface de prediction : demande de la direction pour une adresse
+      </port>
+      <port name="branch_complete" 
+            localisation="east"
+            direction="in">
+        Interface de mise à jour des branchement                           
+      </port>
+
+   </entity>
+
+   
+
+</description>
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor-two_level_branch_predictor_glue.pos
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor-two_level_branch_predictor_glue.pos	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor-two_level_branch_predictor_glue.pos	(revision 30)
@@ -0,0 +1,28 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<description>
+
+   <comment>
+     Test composant sans architecture
+   </comment>
+
+   <entity name="two_level_branch_predictor_glue"
+           type="Two_Level_Branch_Predictor_Glue"
+           schema="1" >
+
+      <port name="predict"         
+            localisation="west" 
+            direction="in">
+        Interface de prediction : demande de la direction pour une adresse
+      </port>
+      <port name="branch_complete" 
+            localisation="east"
+            direction="in">
+        Interface de mise à jour des branchement                           
+      </port>
+
+   </entity>
+
+   
+
+</description>
Index: /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor.pos
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor.pos	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Tools/Viewer/data/two_level_branch_predictor.pos	(revision 30)
@@ -0,0 +1,88 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<description>
+
+   <comment>
+     Ce composant décrit un prédicteur de branchement à deux niveaux
+   </comment>
+
+   <entity name="two_level_branch_predictor"
+           type="Two_Level_Branch_Predictor"
+           schema="1" >
+
+      <port name="clock"           
+            localisation="west" 
+            direction="in">
+        Port d'horloge                                                    
+      </port>
+      <port name="predict"         
+            localisation="west" 
+            direction="in">
+        Interface de prediction : demande de la direction pour une adresse
+      </port>
+      <port name="branch_complete" 
+            localisation="east"
+            direction="in">
+        Interface de mise à jour des branchement                           
+      </port>
+
+   </entity>
+
+   <architecture>
+     <component name="branch_history_table"
+                 type="Branch_History_Table"
+                 size_x="10"
+                 pos_x="50"
+                 size_y="10"
+                 pos_y="20" >
+
+         <port_map name="clock"        
+                   component="two_level_branch_predictor"
+                   port="clock" />
+         <port_map name="predict" 
+                   component="two_level_branch_predictor"
+                   port="predict"/>
+         <port_map name="branch_complete"
+                   component="two_level_branch_predictor"
+                   port="branch_complete" />
+
+      </component>
+
+      <component name="pattern_history_table" 
+                 type="Pattern_History_Table"   
+                 size_x="10"
+                 pos_x="50"
+                 size_y="10"
+                 pos_y="80" >
+
+         <port_map name="clock" 
+                   component="two_level_branch_predictor"
+                   port="clock" />
+         <port_map name="predict"
+                   component="two_level_branch_predictor"
+                   port="predict"/>
+         <port_map name="branch_complete"
+                   component="two_level_branch_predictor"
+                   port="branch_complete" />
+
+      </component>
+
+      <component name="two_level_branch_predictor_glue"
+                 type="Two_Level_Branch_Predictor_Glue"
+                 size_x="10"
+                 pos_x="50"
+                 size_y="10"
+                 pos_y="50" >
+
+         <port_map name="predict"
+                   component="two_level_branch_predictor"
+                   port="predict" />
+         <port_map name="branch_complete"
+                   component="two_level_branch_predictor"
+                   port="branch_complete" />
+
+      </component>
+
+   </architecture>
+
+</description>
Index: /trunk/Makefile.tools
===================================================================
--- /trunk/Makefile.tools	(revision 20)
+++ /trunk/Makefile.tools	(revision 30)
@@ -1,3 +1,6 @@
+#----------------------------------------------------------
 #-----[ Unix Commands ]------------------------------------
+#----------------------------------------------------------
+
 ECHO					= echo
 EXPORT					= export
@@ -39,13 +42,9 @@
 VIEWPDF_FS				= acroread
 
+#----------------------------------------------------------
 #-----[ tools ]--------------------------------------------
-SOCLIB					=  /users/outil/soc/soclib/
-SYSTEMC_systemc				= /users/outil/systemc/systemc-2.1.v1/
-SYSTEMC_systemcass 			= /users/outil/systemc/systemcass/systemcass/latest/i686-Linux.SLA4x/
-SYSTEMC_systemcass_deps 		= $(SYSTEMC_systemcass)
-XILINX					= /dsk/l1/misc/Xilinx91i/
-MODELTECH				= /users/outil/m1archi/modeltech/
-OR1K					= ../../Tools/or32-elf/
-NEWLIB					= ../../Tools/newlib-1.14.0
+#----------------------------------------------------------
+
+include $(MORPHEO_TOPLEVEL)/Makefile.tools_path
 
 #-----[ soclib ]-------------------------------------------
@@ -82,5 +81,5 @@
 
 #-----[ Modeltech ]----------------------------------------
-MODELTECH_ENV				= export LM_LICENSE_FILE=/users/soft/mentor/licence/etc/license.anacad
+MODELTECH_ENV				= export LM_LICENSE_FILE=$(MODELTECH_LICENCE)/license.anacad
 MODELTECH_BIN				= $(MODELTECH)/bin
 MODELTECH_VLIB				= $(MODELTECH_ENV); $(MODELTECH_BIN)/vlib
Index: /trunk/Makefile.tools_path
===================================================================
--- /trunk/Makefile.tools_path	(revision 30)
+++ /trunk/Makefile.tools_path	(revision 30)
@@ -0,0 +1,11 @@
+#-----[ path ]---------------------------------------------
+SOCLIB					=  /users/outil/soc/soclib/
+SYSTEMC_systemc				= /users/outil/systemc/systemc-2.1.v1/
+SYSTEMC_systemcass 			= /users/outil/systemc/systemcass/systemcass/latest/i686-Linux.SLA4x/
+SYSTEMC_systemcass_deps 		= $(SYSTEMC_systemcass)
+XILINX					= /dsk/l1/misc/Xilinx91i/
+MODELTECH				= /users/outil/m1archi/modeltech/
+MODELTECH_LICENCE			= /users/soft/mentor/licence/etc/
+OR1K					= ../../Tools/or32-elf/
+NEWLIB					= ../../Tools/newlib-1.14.0
+
